%global homedir %{_datadir}/%{name}
%global confdir config

%if "%{?scl}" == "ruby193"
    %global scl_prefix %{scl}-
    %global scl_ruby /usr/bin/ruby193-ruby
%else
    %global scl_ruby /usr/bin/ruby
%endif

Name:           foreman-proxy
Version:        1.6.0.30
Release:        2%{dist}
Summary:        Restful Proxy for DNS, DHCP, TFTP, PuppetCA and Puppet

Group:          Applications/System
License:        GPLv3+
URL:            http://theforeman.org/files/todo/%{name}-%{version}.tar.gz
Source0:        %{name}-%{version}.tar.gz
Source1:        foreman-proxy.sysconfig
Source2:        foreman-proxy.init
Source3:        logrotate
Source4:        foreman-proxy.service
Source5:        foreman-proxy.tmpfiles
Source6:        logrotate.systemd
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildArch:      noarch
BuildRequires:  /usr/bin/rename

%if "%{?scl}" == "ruby193" || (0%{?rhel} == 6 && "%{?scl}" == "")
Requires: %{?scl_prefix}ruby(abi)
%else
Requires: %{?scl_prefix}ruby(release)
%endif

Requires:       %{?scl_prefix}rubygems
Requires:       %{?scl_prefix}rubygem(rake) >= 0.8.3
Requires:       %{?scl_prefix}rubygem(sinatra)
Requires:       %{?scl_prefix}rubygem(json)
Requires:       %{?scl_prefix}rubygem(rkerberos)
Requires:       %{?scl_prefix}rubygem(rubyipmi)
Requires:       %{?scl_prefix}rubygem(gssapi)
Requires:       %{?scl_prefix}rubygem(bundler_ext)
Requires:       sudo
Requires:       wget
Requires(pre):  shadow-utils
%if 0%{?rhel} == 6
Requires(post): chkconfig
Requires(preun): chkconfig
Requires(preun): initscripts
Requires(postun): initscripts
%else
Requires(post): systemd-sysv
Requires(post): systemd-units
Requires(preun): systemd-units
Requires(postun): systemd-units
BuildRequires: systemd-units
%endif


%description
Manages DNS, DHCP, TFTP and puppet settings though HTTP Restful API
Mainly used by the foreman project (http://theforeman.org)

%prep
%setup -q

%build

#replace shebangs for SCL
%if %{?scl:1}%{!?scl:0}
  for f in bin/smart-proxy extra/query.rb extra/changelog extra/migrate_settings.rb; do
    sed -ri '1sX(/usr/bin/ruby|/usr/bin/env ruby)X%{scl_ruby}X' $f
  done
  sed -ri '1,$sX/usr/bin/rubyX%{scl_ruby}X' extra/spec/foreman-proxy.init
%endif

#replace default location of 'settings.d'
sed -i '/^---/ a #replace default location of "settings.d"\n:settings_directory: %{_sysconfdir}/%{name}/settings.d\n' \
  %{confdir}/settings.yml.example

# switches to bundler_ext instead of bundler
mv Gemfile Gemfile.in

%install
rm -rf %{buildroot}
install -d -m0755 %{buildroot}%{_datadir}/%{name}
install -d -m0755 %{buildroot}%{_datadir}/%{name}/config
install -d -m0755 %{buildroot}%{_sysconfdir}/%{name}
install -d -m0755 %{buildroot}%{_sysconfdir}/%{name}/settings.d
install -d -m0755 %{buildroot}%{_localstatedir}/lib/%{name}
install -d -m0750 %{buildroot}%{_localstatedir}/log/%{name}
install -d -m0750 %{buildroot}%{_localstatedir}/lib/rpm-state/%{name}
install -d -m0750 %{buildroot}%{_var}/run/%{name}

%if 0%{?rhel} == 6
install -Dp -m0644 %{SOURCE1} %{buildroot}%{_sysconfdir}/sysconfig/%{name}
install -Dp -m0755 %{SOURCE2} %{buildroot}%{_initrddir}/%{name}
install -Dp -m0644 %{SOURCE3} %{buildroot}%{_sysconfdir}/logrotate.d/%{name}
%else
install -Dp -m0644 %{SOURCE4} %{buildroot}%{_unitdir}/%{name}.service
install -Dp -m0644 %{SOURCE5} %{buildroot}%{_prefix}/lib/tmpfiles.d/%{name}.conf
install -Dp -m0644 %{SOURCE6} %{buildroot}%{_sysconfdir}/logrotate.d/%{name}
%endif

mkdir -p %{buildroot}%{_sbindir}
install -m 0755 sbin/foreman-prepare-realm %{buildroot}%{_sbindir}/foreman-prepare-realm
cp -p -r bin extra lib modules Rakefile Gemfile.in bundler.d config.ru VERSION %{buildroot}%{_datadir}/%{name}
chmod a+x %{buildroot}%{_datadir}/%{name}/bin/smart-proxy
rm -rf %{buildroot}%{_datadir}/%{name}/*.rb

# remove all test units from productive release
find %{buildroot}%{_datadir}/%{name} -type d -name "test" |xargs rm -rf

# Move config files to %{_sysconfdir}
install -Dp -m0644 %{confdir}/settings.yml.example %{buildroot}%{_sysconfdir}/%{name}/settings.yml
ln -sv %{_sysconfdir}/%{name}/settings.yml %{buildroot}%{_datadir}/%{name}/config/settings.yml
install -Dp -m0644 %{confdir}/settings.d/*.example %{buildroot}%{_sysconfdir}/%{name}/settings.d/
rename .example '' %{buildroot}%{_sysconfdir}/%{name}/settings.d/*

# Put HTML %{_localstatedir}/lib/%{name}/public
for x in public views; do
  cp -pr $x %{buildroot}%{_localstatedir}/lib/%{name}/
  ln -sv %{_localstatedir}/lib/%{name}/$x %{buildroot}%{_datadir}/%{name}/$x
done

# Put logs in %{_localstatedir}/log/%{name}
ln -sv %{_localstatedir}/log/%{name} %{buildroot}%{_datadir}/%{name}/logs

# Link temp directory to system wide temp
ln -sv %{_tmppath} %{buildroot}%{_datadir}/%{name}/tmp

%clean
rm -rf %{buildroot}

%files
%doc README LICENSE VERSION
%{_datadir}/%{name}
%config(noreplace) %{_sysconfdir}/%{name}
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%attr(-,%{name},%{name}) %{_localstatedir}/lib/%{name}
%dir %attr(-,%{name},%{name}) %{_localstatedir}/lib/rpm-state/%{name}
%attr(-,%{name},%{name}) %{_localstatedir}/log/%{name}
%attr(-,%{name},%{name}) %{_var}/run/%{name}
%attr(-,%{name},root) %{_datadir}/%{name}/config.ru
%{_sbindir}/foreman-prepare-realm
%if 0%{?rhel} == 6
%{_initrddir}/%{name}
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}
%else
%{_unitdir}/%{name}.service
%{_prefix}/lib/tmpfiles.d/%{name}.conf
%endif

%pre
# Add the "foreman-proxy" user and group
getent group foreman-proxy >/dev/null || \
  groupadd -r foreman-proxy
getent passwd foreman-proxy >/dev/null || \
  useradd -r -g foreman-proxy -d %{homedir} -s /sbin/nologin -c "Foreman Proxy deamon user" foreman-proxy

# Keep monolithic config in case it's replaced with the new default
if [ $1 == 2 -a ! -e %{_sysconfdir}/%{name}/settings.d ]; then
  test -e %{_localstatedir}/lib/rpm-state/%{name} || mkdir -p %{_localstatedir}/lib/rpm-state/%{name}
  cp %{_sysconfdir}/%{name}/settings.yml %{_localstatedir}/lib/rpm-state/%{name}/settings.yml.orig
fi

exit 0

%post
# Migrate legacy monolithic proxy config
if [ $1 == 2 -a -e %{_localstatedir}/lib/rpm-state/%{name}/settings.yml.orig ]; then
  pushd %{_localstatedir}/lib/rpm-state/%{name} >/dev/null
  if %{homedir}/extra/migrate_settings.rb settings.yml.orig; then
    mv settings.yml %{_sysconfdir}/%{name}
    sed -i '/^---/ a #replace default location of "settings.d"\n:settings_directory: %{_sysconfdir}/%{name}/settings.d\n' \
      %{_sysconfdir}/%{name}/settings.yml
    rm -f settings.yml.orig
    ls *.yml >/dev/null 2>&1 && mv *.yml %{_sysconfdir}/%{name}/settings.d/
  else
    rm -f settings.yml.orig
  fi
  popd >/dev/null
fi

%if 0%{?rhel} == 6
  /sbin/chkconfig --add %{name}
  exit 0
%else
  if [ $1 -eq 1 ]; then
    /bin/systemctl daemon-reload >/dev/null 2>&1 || :
  fi
%endif

%preun
if [ $1 -eq 0 ] ; then
  # Package removal, not upgrade
  %if 0%{?rhel} == 6
    /sbin/service %{name} stop >/dev/null 2>&1
    /sbin/chkconfig --del %{name}
  %else
    /bin/systemctl --no-reload disable foreman-proxy.service >/dev/null 2>&1 || :
    /bin/systemctl stop foreman-proxy.service >/dev/null 2>&1 || :
  %endif
fi

%postun
%if 0%{?rhel} == 6
  if [ $1 -ge 1 ] ; then
    /sbin/service %{name} restart >/dev/null 2>&1
  fi
%else
  /bin/systemctl daemon-reload >/dev/null 2>&1 || :
  if [ $1 -ge 1 ] ; then
    /bin/systemctl try-restart foreman-proxy.service >/dev/null 2>&1 || :
  fi
%endif


%changelog
* Mon Sep 22 2014 Mike Burns <mbrns@redhat.com> 1.6.0.30-2
- Fix no such file or directory when upgrading rhbz#1141730

* Wed Aug 27 2014 Jason Montleon <jmontleo@redhat.com> 1.6.0.30-1
- fixes #6908 - update request tests for latest Chef release
  (dcleal@redhat.com)
- fixes #6956 - rack 1.1 minimum required for Rack::Server#start
  (dcleal@redhat.com)

* Wed Aug 20 2014 Jason Montleon <jmontleo@redhat.com> 1.6.0.29-1
- refs #6542 - ship freeipa script for creating users / BZ1117793
  (stbenjam@redhat.com)

* Mon Aug 18 2014 Jason Montleon <jmontleo@redhat.com> 1.6.0.28-1
- fixes #7080: symbols are no longer being sorted (dmitri@appliedlogic.ca)
- fixes #7060: puppet gem is no longer required if puppetca is disabled.
  (dmitri@appliedlogic.ca)

* Wed Aug 13 2014 Jason Montleon <jmontleo@redhat.com> 1.6.0.27-1
- Revert "fixes #7060: puppet gem is no longer required if puppetca is
  disabled." (jmontleo@redhat.com)

* Wed Aug 13 2014 Jason Montleon <jmontleo@redhat.com>
- Revert "fixes #7060: puppet gem is no longer required if puppetca is
  disabled." (jmontleo@redhat.com)

* Wed Aug 13 2014 Jason Montleon <jmontleo@redhat.com> 1.6.0.25-1
- fixes #7062: facts module uses correct path for 'requires'
  (dmitri@appliedlogic.ca)
- fixes #7060: puppet gem is no longer required if puppetca is disabled.
  (dmitri@appliedlogic.ca)

* Wed Aug 13 2014 Jason Montleon <jmontleo@redhat.com> 1.6.0.24-1
- fixes #6542 - ship freeipa users script with the smart proxy
  (stbenjam@redhat.com)
- fixes #6722 - correct require for kerberos utilities (dcleal@redhat.com)

* Tue Jul 29 2014 Jason Montleon <jmontleo@redhat.com> 1.6.0.23-1
- Merge remote-tracking branch 'upstream/develop' into SATELLITE-6.0.4
  (jmontleo@redhat.com)
- Fixes #6790: Restrict ci_reporter gem to less than 2.0.0 to fix CI.
  (aaron@serendipity.cx)
- Fixes #6772: added support for testing of plugins (dmitri@appliedlogic.ca)
- fixes #4699 - support Puppet environments API for directory envs
  (dcleal@redhat.com)

* Tue Jul 22 2014 Jason Montleon <jmontleo@redhat.com> 1.6.0.22-1
- Merge remote-tracking branch 'upstream/develop' into SATELLITE-6.0.4
  (jmontleo@redhat.com)
- Fixes #6689 - Allow nil mac address for TFTP API calls that do not require a
  MAC (treydock@gmail.com)
- fixes #6700 - tests for Proxy::Puppet::Runner shell methods
  (aaron@serendipity.cx)
- fixes #6661: trailing slash is not required in urls (dmitri@appliedlogic.ca)

* Tue Jul 15 2014 Jason Montleon <jmontleo@redhat.com> 1.6.0.21-1
- Merge remote-tracking branch 'upstream/develop' into SATELLITE-6.0.4
  (jmontleo@redhat.com)
- fixes #6588 - don't load user settings when testing default settings
  (dcleal@redhat.com)

* Mon Jul 14 2014 Jason Montleon <jmontleo@redhat.com> 1.6.0.20-1
- add rpm spec file, rel-eng files, additional sources (jmontleo@redhat.com)

* Mon Jul 14 2014 Jason Montleon <jmontleo@redhat.com> 1.6.0.19-1
- Merge remote-tracking branch 'upstream/develop' into SATELLITE-6.0.4
  (jmontleo@redhat.com)
- fixes #6585 - Update Proxy::Util::CommandTask to handle Ruby 1.8 and 1.9+
  (aaron@serendipity.cx)
- fixes #6584 - Replace Kernel#open with File.open (aaron@serendipity.cx)
- fixes #6583 - Use Enumerable#find instead of each where possible
  (aaron@serendipity.cx)
- Fixes #6412: Trying to remove a DHCP record fails due to an invalid subnet
  check (dswift@brightroll.com)
- Fixes #6396: an error removing a DHCP record (record doesn't exist) stops the
  delete process for a host (dswift@brightroll.com)
- fixes #6275 - idempotence needs clone of original data and to handle *_port
  (dcleal@redhat.com)

* Mon Jul 07 2014 Jason Montleon <jmontleo@redhat.com> 1.6.0.18-1
- Merge remote-tracking branch 'upstream/develop' into SATELLITE-6.0.4
  (jmontleo@redhat.com)
- fixes #6289: avoids concurrent downloads of files with the same name and
  destination dir. (dmitri@appliedlogic.ca)
- fixes #6377 - incorrect dhcp providers server virsh.rb loadSubnetData
  (vincent@kramar.me)
- fixes #6085 - fixed virsh dhcp provider netmask interpretation
  (vincent@kramar.me)
- fixes #6474: smart-proxy relies on Bundler to load sinatra dependency
  (dmitri@appliedlogic.ca)
- fixes #6306: removed possible namespace collisions with puppet and chef
  (dmitri@appliedlogic.ca)
- fixes #6436: plugins are now being loaded after core modules
  (dmitri@appliedlogic.ca)
- fixes #6341 - Add support for 64-bit MAC addresses (treydock@gmail.com)
- fixes #6334 - pass virsh_network to virsh DNS provider (dcleal@redhat.com)
- refs #4866 - Added config/settings.d/*yml to gitignore (lzap+git@redhat.com)
- Fixes #4866: Breaking up monolithic smart-proxy into modules
  (dmitri@appliedlogic.ca)
- Fixes #6086 - stop remote command execution and path exploit in TFTP API
  (CVE-2014-0007) (gsutclif@redhat.com)
- fixes #5675 - expect dns_key setting to be nil if not set (dcleal@redhat.com)
- fixes #5856 - use public initializer for Puppet settings (dcleal@redhat.com)
- refs #5987 - remove unused packaging files (dcleal@redhat.com)
- Fixes #5907 - Look at all records when suggesting IPs (gsutclif@redhat.com)
- fixes #5677 - handle booleans from settings.yml as bools (dcleal@redhat.com)
- refs #5793 - add pkg:generate_source rake task to create tar.bz2
  (dcleal@redhat.com)

* Mon Jul 07 2014 Jason Montleon <jmontleo@redhat.com> 1.6.0.17-1
- update additional source file names (jmontleo@redhat.com)

* Mon Jul 07 2014 Jason Montleon <jmontleo@redhat.com> 1.6.0.16-1
- add additional source files (jmontleo@redhat.com)

* Mon Jul 07 2014 Jason Montleon <jmontleo@redhat.com> 1.6.0.15-1
- fix source file name (jmontleo@redhat.com)

* Mon Jul 07 2014 Jason Montleon <jmontleo@redhat.com> 1.6.0.14-1
- fix source file name (jmontleo@redhat.com)

* Mon Jul 07 2014 Jason Montleon <jmontleo@redhat.com> 1.6.0.13-1
- fix source file name (jmontleo@redhat.com)

* Mon Jul 07 2014 Jason Montleon <jmontleo@redhat.com> 1.6.0.12-1
- add url to source file name (jmontleo@redhat.com)

* Mon Jul 07 2014 Jason Montleon <jmontleo@redhat.com> 1.6.0.11-1
- add url to source file name (jmontleo@redhat.com)

* Mon Jul 07 2014 Jason Montleon <jmontleo@redhat.com> 1.6.0.10-1
- update foreman-proxy spec file to support RHEL 7 properly
  (jmontleo@redhat.com)

* Wed Apr 16 2014 Dominic Cleal <dcleal@redhat.com> - 1.6.0-0.develop
- Bump to version 1.6-develop

* Thu Jan 16 2014 Dominic Cleal <dcleal@redhat.com> - 1.5.0-0.develop
- Bump to version 1.5-develop

* Thu Nov 21 2013 Dominic Cleal <dcleal@redhat.com> - 1.4.0-0.develop
- Bump and change versioning scheme (#3712)
- Ship config.ru for running under Passenger

* Thu Sep 05 2013 Lukas Zapletal <lzap+rpm[@]redhat.com> - 1.3.9999-1
- bump to version 1.3-develop

* Wed Jul 03 2013 Dominic Cleal <dcleal@redhat.com> - 1.2.9999-3
- add rubyipmi dependency for BMC support

* Tue Jun 11 2013 Lukas Zapletal <lzap+rpm[@]redhat.com> - 1.2.9999-2
- fixed service file for systemd
- /etc/sysconfig configuration is no longer in use for systemd

* Thu May 16 2013 Martin Bačovský <mbacovsk@redhat.com> 1.2.9999-1
- added support for building with tito

* Mon Feb 4 2013 shk@redhat.com 1.1-1
- 1.1 final.

* Fri Jan 25 2013 shk@redhat.com 1.1RC3-1
- Updated to RC3

* Wed Jan 09 2013 shk@redhat.com 1.1RC2-1
- Updated to RC2
- Removed net-ping dependency

* Tue Jan 1 2013 shk@redhat.com 1.1RC1-1
- Update to 1.1RC1

* Thu Aug 30 2012 jmontleo@redhat.com 1.0.0-3
- Update to include up to 330dbef353

* Sun Aug 05 2012 jmontleo@redhat.com 1.0.0-2
- Update to pull in fixes

* Mon Jul 23 2012 jmontleo@redhat.com 1.0.0-1
- Update packages for Foreman 1.0 Release.

* Wed Jul 18 2012 jmontleo@redhat.com 1.0.0-0.7
- Updated pacakages for Foreman 1.0 RC5 and Proxy RC2

* Thu Jul 05 2012 jmontleo@redhat.com 1.0.0-0.6
- Fix foreman-release to account for different archs. Pull todays source.

* Wed Jul 04 2012 jmontleo@redhat.com 1.0.0-0.5
- Bump version number for foreman RC3 and build with todays develop branch

* Sun Jul 01 2012 jmontleo@redhat.com 1.0.0-0.4
- Pull todays develop branch

* Fri Jun 29 2012 jmontleo@redhat.com 1.0.0-0.2
- Rebuild with develop branch from today. Hopefully we're really 1.0.0 RC2 this time

* Tue Jun 19 2012 jmontleo@redhat.com 0.5.1-9
- Rebuild with todays develop branch.

* Thu Jun 14 2012 jmontleo@redhat.com 0.5.1-8
- Rebuild with todays develop branch.

* Tue May 08 2012 Jason Montleon <jmontleo@redhat.com> - 0.5.1-1
- update version to match foreman package version

* Wed Dec 28 2011 Ohad Levy <ohadlevy@gmail.com> - 0.3.1
- rebuilt

* Tue Nov 08 2011 Ohad Levy <ohadlevy@gmail.com> - 0.3
- rebuilt

* Wed Sep 28 2011 Ohad Levy <ohadlevy@gmail.com> - 0.3rc2
- rebuilt

* Sat Sep 10 2011 Ohad Levy <ohadlevy@gmail.com> - 0.3rc1
- rebuilt

* Mon Jun 6 2011 Ohad Levy <ohadlevy@gmail.com> - 0.2
- rebuilt

* Thu May 26 2011 ohadlevy@gmail.com - 0.2rc2-2
- rebuilt

* Thu Feb 24 2011 Ohad Levy <ohadlevy@gmail.com> - 0.1.0rc
- new package built with tito

* Wed Jan 26 2011 Lukas Zapletal <lzap+git@redhat.com> - 0.1.0
- new package built with tito
